'use strict';

const should = require('should'); //eslint-disable-line

const Container = require('./../../dist/commonjs').Container;
const getPropertyDescriptor = require('./../../dist/commonjs').getPropertyDescriptor;

const container = new Container();

describe('Dependency Injection Container Get Property Descriptor Test', () => {

  class BaseClass {

    get config() {
      return this._config;
    }
    set config(value) {
      this._config = value;
    }

  }

  class DerivedClass extends BaseClass {}

  beforeEach(() => {
    container.clear();
  });

  it('should get the property descriptor of the specified derived class', () => {

    const testKey = 'test';

    container.register(testKey, DerivedClass);

    const instance = container.resolve(testKey);

    const propertyDescriptor = getPropertyDescriptor(instance, 'config');

    should(propertyDescriptor).not.be.undefined();
  });

});
