'use strict';

const should = require('should');

const Container = require('./../../dist/commonjs').Container;

const container = new Container();

class TestType {}
const testTypeKey = 'dependencyTestKey';

describe('Type Registration Dependencies Test', () => {

  beforeEach(() => {
    container.clear();
  });

  it('should configure the registered type with the given dependencies (single)', () => {

    const dependenciesTestValue = 'anyKey';

    container
      .register(testTypeKey, TestType)
      .dependencies(dependenciesTestValue);

    const registration = container.getRegistration(testTypeKey);

    const dependencySettings = registration.settings.dependencies;

    should(dependencySettings).be.eql([dependenciesTestValue]);
  });

  it('should configure the registered type with the given dependencies (multiple)', () => {

    const dependency1Key = 'anyKey';
    const dependency2Key = 'anyKey';

    container
      .register(testTypeKey, TestType)
      .dependencies(dependency1Key, dependency2Key);

    const registration = container.getRegistration(testTypeKey);

    const dependencySettings = registration.settings.dependencies;

    should(dependencySettings).be.eql([dependency1Key, dependency2Key]);
  });
});
