'use strict';

const should = require('should');

const Container = require('./../../dist/commonjs').Container;

const container = new Container();

class TestType {}
const testTypeKey = 'injectIntoTargetTest';

describe('Type Registration with Injection Target Test', () => {

  beforeEach(() => {
    container.clear();
  });

  it('should set the registered type to be injected into the designated target', () => {

    const target = 'testTarget';

    container
      .register(testTypeKey, TestType)
      .injectInto(target);

    const registration = container.getRegistration(testTypeKey);

    const targetSetting = registration.settings.injectInto;

    should(targetSetting).be.eql(target);
  });
});
