'use strict';

const should = require('should');

const Container = require('./../../dist/commonjs').Container;

const container = new Container();

describe('Type Registration With Lazy Injection Test', () => {

  class TestType {}
  const testTypeKey = 'injectLazyTest';

  beforeEach(() => {
    container.clear();
  });

  it('should set the registered type as lazy', () => {

    container
      .register(testTypeKey, TestType)
      .injectLazy();

    const registration = container.getRegistration(testTypeKey);

    const lazySetting = registration.settings.wantsLazyInjection;

    should(lazySetting).be.eql(true);
  });
});
