'use strict';

const should = require('should');

const Container = require('./../../dist/commonjs').Container;

const container = new Container();

describe('Type Registration Set Tag Test', () => {

  class TestType {}
  const testTypeKey = 'setTagTest';

  beforeEach(() => {
    container.clear();
  });

  it('should register the type with the provided tag-value pair', () => {

    const testAttribute = {key: 'test1', value: 'value1'};

    container
      .register(testTypeKey, TestType)
      .setTag(testAttribute.key, testAttribute.value);

    const registration = container.getRegistration(testTypeKey);
    const tags = registration.settings.tags;

    should(tags[testAttribute.key]).be.equal(testAttribute.value);
  });
});
