'use strict';

const should = require('should');

const Container = require('./../../dist/commonjs').Container;

const container = new Container();

describe('Type Registration As Singleton Test', () => {

  class TestType {}
  const testTypeKey = 'singletonTest';

  beforeEach(() => {
    container.clear();
  });

  it('should register the given type as a singleton', () => {

    container
      .register(testTypeKey, TestType)
      .singleton();

    const registration = container.getRegistration(testTypeKey);

    should(registration.settings.isSingleton).be.equal(true);
  });
});
