'use strict';

const should = require('should');

const Container = require('./../../dist/commonjs').Container;

const container = new Container();

describe('Type Registration With Tags Test', () => {

  class TestType {}
  const testTypeKey = 'tagsTest';

  beforeEach(() => {
    container.clear();
  });

  it('should register the given type with the given tags', () => {

    const tag1 = 'exampleTag1';
    const tag2 = 'exampleTag2';

    container
      .register(testTypeKey, TestType)
      .tags(tag1, tag2);

    const registration = container.getRegistration(testTypeKey);

    const tags = registration.settings.tags;

    const tagKeys = Object.keys(tags);

    should(tagKeys).has.containEql(tag1);
    should(tagKeys).has.containEql(tag2);
  });
});
