'use strict';

const should = require('should');

const Container = require('./../../dist/commonjs').Container;

const container = new Container();

describe('Type Registration Unregister Test', () => {

  class TestType {}
  const testTypeKey = 'unregisterTest';

  beforeEach(() => {
    container.clear();
  });

  it('should unregister the type registered under the given key', () => {

    container.register(testTypeKey, TestType);
    container.unregister(testTypeKey);

    const typeIsRegistered = container.isRegistered(testTypeKey);

    should(typeIsRegistered).be.equal(false);
  });

  it('should not throw an error, if the given key is not registered', () => {
    container.unregister(TestType);
  });
});
